; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; 3D objects demo
pvtCard = CreatePivot()
mshCard = CreateMesh(pvtCard)
sfcCard = CreateSurface(mshCard)
v1 = AddVertex(sfcCard, -90, 125, 0)
v2 = AddVertex(sfcCard, 90, 125, 0)
v3 = AddVertex(sfcCard, -90, -125, 0)
v4 = AddVertex(sfcCard, 90, -125, 0)
VertexTexCoords sfcCard, v1, 0, 0
VertexTexCoords sfcCard, v2, 1, 0
VertexTexCoords sfcCard, v3, 0, 1
VertexTexCoords sfcCard, v4, 1, 1
AddTriangle(sfcCard, v1, v2, v3)
AddTriangle(sfcCard, v3, v2, v4)
mshAce = CopyMesh(mshCard, pvtCard)
RotateMesh mshAce, 0, 180, 0
texCard = LoadTexture("demos\card.png", 4)
EntityTexture mshCard, texCard
texAce = LoadTexture("demos\ace.png", 4)
EntityTexture mshAce, texAce

objCard = nS_Convertentity(pvtCard)

pvtCube = CreateCube()
texCube = LoadTexture("demos\cube.jpg")
ScaleMesh pvtCube, 80, 80, 80
pvtCube2 = CopyMesh(pvtCube, pvtCube)
ScaleEntity pvtCube2, 0.5, 2, 0.5
EntityTexture pvtCube, texCube
EntityTexture pvtCube2, texCube

objCube = nS_Convertentity(pvtCube)
nS_Turn3DObject objCube, -20, 0, 0

ClsColor 40, 155, 60
While Not KeyHit(1)

	DemoBeginFrame()

	spd# = 120 * DeltaTime
	
	nS_Position3DObject objCard, scrWidth / 3, scrHeight / 2
	nS_Turn3DObject objCard, spd, spd, -spd

	nS_Position3DObject objCube, scrWidth / 3 * 2, scrHeight / 2
	nS_Turn3DObject objCube, 0, spd, 0
	
	DemoEndFrame("3D Objects")

Wend

Reset()