; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; Animations/Smoothness comparison
ClsColor 200, 150, 100

speed# = 10
ox# = -128

; ===========================================
; nSprite 2
nsl = MilliSecs()
sprOrc = nS_LoadAnimImage("demos\orc.tga", 128, 128, 0, 8, 2)
nS_AnimateImage sprOrc, nS_ANIM_LOOP, speed, 0, 7
nS_HandleImage sprOrc, 48, 73
sprRoad = nS_LoadImage("demos\road.png")
sprGrass = nS_LoadImage("demos\grass.png")
sprTrees = nS_LoadImage("demos\trees.tga", 1+2)
sprTrees2 = nS_CopyImage(sprTrees)

nsl = MilliSecs() = nsl
; ===========================================

; ===========================================
; Blitz
bl = MilliSecs()
Local imgOrc[6]
imgOrc[0] = LoadAnimImage("demos\orc.tga", 128, 128, 0, 8)
HandleImage imgOrc[0], 48, 73
imgOrc[1] = CopyImage(imgOrc[0])
imgOrc[2] = CopyImage(imgOrc[0])
imgOrc[3] = CopyImage(imgOrc[0])
imgOrc[4] = CopyImage(imgOrc[0])
imgOrc[5] = CopyImage(imgOrc[0])
imgOrc[6] = CopyImage(imgOrc[0])
ScaleImage imgOrc[1], 1.33, 1.33
ScaleImage imgOrc[2], 1.67, 1.67
ScaleImage imgOrc[3], 2.00, 2.00
ScaleImage imgOrc[4], 1.55, 1.55
ScaleImage imgOrc[5], 1.10, 1.10
ScaleImage imgOrc[6], 0.57, 0.57
id = 0
imgRoad = LoadImage("demos\road.png")
imgGrass = LoadImage("demos\grass.png")
imgTrees = LoadAnimImage("demos\trees.tga", 128, 128, 0, 8)
bl = MilliSecs() - bl
; ===========================================

Const TC = 150
Local tx[TC]
Local ty[TC]
Local tox[TC]
Local toy[TC]
For i = 0 To TC
	tx[i] = Rand(0, scrWidth)
	ty[i] = Rand(0, scrHeight/2)
	tox[i] = Rand(0, 3)
	toy[i] = Rand(0, 1)
Next

While Not KeyHit(1)

	DemoBeginFrame()
	
	ox = ox + DeltaTime * 50
	If ox > scrWidth + 128 Then
		ox = -128
	End If

	; ===========================================
	; nSprite 2
	nsd = MilliSecs()

	For ix = 0 To scrWidth / 64
		For iy = 0 To scrHeight / 64 / 2
			nS_DrawImage sprGrass, ix*64, iy*64
		Next
	Next
	For i = 0 To TC
		If ty[i] < scrHeight/4 Then
			nS_DrawImageRect sprTrees, tx[i] - 100, ty[i] - 25, tox[i]*128, toy[i]*128, 128, 128
		End If
	Next
	For i = 0 To scrWidth / 64
		nS_DrawImage sprRoad, i * 64, scrHeight * 0.25
	Next
	If ox > 150 And ox < 200
		s# = (ox - 150.0) / 50 + 1
		nS_ScaleImage sprOrc, s, s, True
	End If
	If ox > 250 And ox < 300
		s# = 1 - (ox - 250.0) / 35 + 1
		nS_ScaleImage sprOrc, s, s, True
	End If
	If ox > 400 Then
		s# = 1
		nS_ScaleImage sprOrc, s, s, True
	End If
	nS_DrawImage sprOrc, ox, scrHeight * 0.25 + 32
	For i = 0 To TC
		If ty[i] > scrHeight/4 Then
			nS_DrawImageRect sprTrees2, tx[i] - 100, ty[i] - 25, tox[i]*128, toy[i]*128, 128, 128
		End If
	Next
	nsd = MilliSecs() - nsd
	; ===========================================

	nS_Color 0, 0, 0, 0.5
	nS_Rect 0, 0, 185, 30
	
	nS_Text 0, 0, "FPS: " + FPS
	nS_Text 0, 15, "Sprites: " + SpriteCount
	
	nS_Rect scrWidth / 4, 30, scrWidth / 2, 15
	nS_Text scrWidth/2, 30, "Animations and movement smoothness comparison with Blitz", True
	
	nS_Rect 50, 100, 285, 15
	nS_Text 50, 100, "nSprite 2 [Loading: " + nsl + "ms | Drawing: " + nsd + "ms]"

	RenderWorld
	SpriteCount = nS_SpriteCount
	
	; 2D Render

	; ===========================================
	; Blitz
	bd = MilliSecs()

	For ix = 0 To scrWidth / 64
		For iy = 0 To scrHeight / 64 / 2
			DrawImage imgGrass, ix*64, iy*64+scrHeight/2
		Next
	Next
	For i = 0 To TC
		If ty[i] < scrHeight/4 Then
			DrawImage imgTrees, tx[i] - 100, ty[i]+scrHeight/2 - 100, tox[i]+toy[i]*4
		End If
	Next
	For i = 0 To scrWidth / 64
		DrawImage imgRoad, i * 64, scrHeight * 0.66
	Next
	If ox > 200 And ox < 216
		id = 1
	End If
	If ox > 216 And ox < 232
		id = 2
	End If
	If ox > 232 And ox < 250
		id = 3
	End If
	If ox > 300 And ox < 316
		id = 4
	End If
	If ox > 316 And ox < 332
		id = 5
	End If
	If ox > 332 And ox < 350
		id = 6
	End If
	If ox > 400
		id = 0
	End If
	frame# = frame + DeltaTime * speed
	While frame >= 8
		frame = frame - 8
	Wend
	DrawImage imgOrc[id], ox, scrHeight * 0.66 + 32, Floor(frame#)
	For i = 0 To TC
		If ty[i] > scrHeight/4 Then
			DrawImage imgTrees, tx[i] - 100, ty[i]+scrHeight/2 - 100, tox[i]+toy[i]*4
		End If
	Next
	Color 0, 0, 0
	Rect 15, scrHeight-20, scrWidth-30, 15
	Rect 50, 300, 285, 15
	Color 255, 255, 255
	Text scrWidth/2, scrHeight - 20, "Press ESC to go to the next demo", True
	Text 50, 300, "Blitz [Loading: " + bl + "ms | Drawing: " + obd + "ms]"
	Rect 0, scrHeight/2-5, scrWidth, 10
	Flip False
	obd = MilliSecs() - bd
	; ===========================================

Wend

Reset()