; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

bkg = nS_LoadImage("demos\cb.jpg", 0)
nS_ResizeImage bkg, scrWidth, scrHeight
nS_ImageAlpha bkg, 0.7

gear1 = nS_LoadImage("demos\gear.bmp")
nS_MidHandle gear1
nS_AddCollisionPolyPoint(gear1, 64, 0, 0)
nS_AddCollisionPolyPoint(gear1, 77, 51, 0)
nS_AddCollisionPolyPoint(gear1, 128, 64, 0)
nS_AddCollisionPolyPoint(gear1, 77, 77, 0)
nS_AddCollisionPolyPoint(gear1, 64, 128, 0)
nS_AddCollisionPolyPoint(gear1, 51, 77, 0)
nS_AddCollisionPolyPoint(gear1, 0, 64, 0)
nS_AddCollisionPolyPoint(gear1, 51, 51, 0)
nS_AddCollisionPolyPoint(gear1, 64, 0, 0)
nS_ResizeImage gear1, 100, 100

gear2 = nS_CopyImage(gear1)
nS_ResizeImage gear2, 70, 70
nS_UpdateCollisions gear2

lever = nS_LoadImage("demos\lever.jpg", 0)
nS_FlipImage lever, False, True
nS_HandleImage lever, 128, 4
nS_AddCollisionPolyPoint lever, 0, 0, 0
nS_AddCollisionPolyPoint lever, 128, 0, 0
nS_AddCollisionPolyPoint lever, 128, 8, 0
nS_AddCollisionPolyPoint lever, 0, 8, 0
nS_AddCollisionPolyPoint lever, 0, 0, 0

crate = nS_LoadImage("demos\crate.jpg", 0)
nS_AddCollisionPolyPoint crate, 0, 0, 0
nS_AddCollisionPolyPoint crate, 32, 0, 0
nS_AddCollisionPolyPoint crate, 32, 32, 0
nS_AddCollisionPolyPoint crate, 0, 32, 0
nS_AddCollisionPolyPoint crate, 0, 0, 0

g1s = nS_CopyImage(gear1)
g2s = nS_CopyImage(gear2)
ls = nS_CopyImage(lever)
cs = nS_CopyImage(crate)
nS_ImageAlpha g1s, 0.5
nS_ImageAlpha g2s, 0.5
nS_ImageAlpha ls, 0.5
nS_ImageAlpha cs, 0.5
nS_ImageColor g1s, 0, 0, 0
nS_ImageColor g2s, 0, 0, 0
nS_ImageColor ls, 0, 0, 0
nS_ImageColor cs, 0, 0, 0

c1x = 245
c2x = 300
c1y# = 270
c2y# = 290

grab = nS_CreateImage(256, 128)
nS_ScaleImage grab, 2, 1

; Custom collision
While Not KeyHit(1)

	DemoBeginFrame()
	
	; Gears
	nS_RotateImage gear1, DeltaTime * 50
	nS_RotateImage g1s, DeltaTime * 50
	nS_UpdateCollisions gear1
	While nS_Collided(gear1, 150, 300, gear2, 212, 300)
		nS_RotateImage(gear2, -1)
		nS_RotateImage g2s, -1
		nS_UpdateCollisions gear2
	Wend
	; Gear and lever
	If Not nS_Collided(gear2, 212, 300, lever, 360, 290)
		nS_RotateImage(lever, -1)
		nS_UpdateCollisions lever
	End If
	While nS_Collided(gear2, 212, 300, lever, 360, 290)
		nS_RotateImage(lever, 1)
		nS_UpdateCollisions lever
	Wend
	nS_RotateImage ls, nS_ImageAngle(lever), True
	; Crates
	If Not nS_Collided(crate, c1x, c1y, lever, 360, 290)
		c1y = c1y + 150 * DeltaTime
	End If
	While nS_Collided(crate, c1x, c1y, lever, 360, 290)
		c1y = c1y - 30 * DeltaTime
	Wend
	If Not nS_Collided(crate, c2x, c2y, lever, 360, 290)
		c2y = c2y + 150 * DeltaTime
	End If
	While nS_Collided(crate, c2x, c2y, lever, 360, 290)
		c2y = c2y - 30 * DeltaTime
	Wend
	
	; Rendering
	nS_Cls()
	
	nS_DrawImage bkg, 0, 0

	nS_Color 0, 0, 0, 0.9
	nS_Rect 100, 55, 512+20, 128+20, False, 10
	nS_DrawImage grab, 110, 65

	nS_DrawImage g1s, 155, 305
	nS_DrawImage g2s, 217, 305
	nS_DrawImage ls, 365, 295
	nS_DrawImage cs, c1x+5, c1y+5
	nS_DrawImage cs, c2x+5, c2y+5
	
	nS_DrawImage gear1, 150, 300
	nS_DrawImage gear2, 212, 300
	nS_DrawImage lever, 360, 290
	nS_DrawImage crate, c1x, c1y
	nS_DrawImage crate, c2x, c2y
	If showCol Then
		nS_DrawCollisions(gear1, 150, 300)
		nS_DrawCollisions(gear2, 212, 300)
		nS_DrawCollisions(lever, 360, 290)
		nS_DrawCollisions(crate, c1x, c1y)
		nS_DrawCollisions(crate, c2x, c2y)
	End If
	
	mh = MouseHit(1)
	If DrawButton(430, 330, 120, 30, ts$ + " Collisions", mh) Then
		If showCol Then
			showCol = False
		Else
			showCol = True
		End If
	End If		
	If DrawButton(430, 280, 120, 30, "Turn Grab " + tb$, mh) Then
		If gon Then
			gon = False
		Else
			gon = True
		End If
	End If
	
	DemoEndFrame("Custom collisions [buttons]")

	If gon Then
		tb$ = "OFF"
		nS_GrabImage grab, 100, 250
	Else
		tb$ = "ON"
	End If
	If showCol Then
		ts$ = "Hide"
	Else
		ts$ = "Show"
	End If

Wend

Reset()