; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; GUI module demo

; Windows part
pnlBkg = nS_CreatePanel(scrWidth/2-1, scrHeight/2, nS_PANEL_SLIM_RAISED)
txtName = nS_CreateTextBox(scrWidth/4)
pnlDn = nS_CreatePanel(scrWidth/3, scrHeight/4, nS_PANEL_SLIM_SUNKEN)
chkRock = nS_CreateCheckBox("Rock")
chkPunk = nS_CreateCheckBox("Punk")
chkTechno = nS_CreateCheckBox("Techno")
chkClassical = nS_CreateCheckBox("Classical")
btnCheck = nS_CreateButton(100, 25)
btnFinish = nS_CreateButton(100, 25)

nS_ControlSetCaption(btnFinish, "Finish")
nS_ControlSetTooltip(btnFinish, "Ends this demo and go on to the next")
nS_ControlSetTooltip(txtName, "Just enter your name!")
nS_ControlSetTooltip(chkRock, "Check for rock")
nS_ControlSetTooltip(chkPunk, "Check for punk")
nS_ControlSetTooltip(chkTechno, "Check for techno")
nS_ControlSetTooltip(chkClassical, "Check for classical")
nS_ControlSetCaption(btnCheck, "Check all")

nS_ControlSetPosition(pnlBkg, 0, scrHeight/4)
nS_ControlSetPosition(btnFinish, scrWidth/2 - 125, scrHeight/4*3 - 50)
nS_ControlSetPosition(txtName, scrWidth*0.2, scrHeight/4 + 15)
nS_ControlSetPosition(pnlDn, scrWidth/12, scrHeight/4+50)
nS_ControlSetPosition(chkRock, scrWidth/12+10, scrHeight/4+65)
nS_ControlSetPosition(chkPunk, scrWidth/12+10, scrHeight/4+90)
nS_ControlSetPosition(chkTechno, scrWidth/12+10, scrHeight/4+115)
nS_ControlSetPosition(chkClassical, scrWidth/12+10, scrHeight/4+140)
nS_ControlSetPosition(btnCheck, scrWidth/4, scrHeight/4+65)
nS_ControlEnable(chkTechno, False)

; nSprite 2 part
pnlBkg2 = nS_CreatePanel(scrWidth/2-1, scrHeight/2, nS_PANEL_SLIM_RAISED, nS_STYLE_NS2GUI)
txtName2 = nS_CreateTextBox(scrWidth/4, nS_STYLE_NS2GUI)
pnlDn2 = nS_CreatePanel(scrWidth/3, scrHeight/4, nS_PANEL_SLIM_SUNKEN, nS_STYLE_NS2GUI)
chkRock2 = nS_CreateCheckBox("Rock", nS_STYLE_NS2GUI)
chkPunk2 = nS_CreateCheckBox("Punk", nS_STYLE_NS2GUI)
chkTechno2 = nS_CreateCheckBox("Techno", nS_STYLE_NS2GUI)
chkClassical2 = nS_CreateCheckBox("Classical", nS_STYLE_NS2GUI)
btnCheck2 = nS_CreateButton(100, 25, nS_STYLE_NS2GUI)
btnFinish2 = nS_CreateButton(100, 25, nS_STYLE_NS2GUI)

nS_ControlSetCaption(btnFinish2, "Finish")
nS_ControlSetTooltip(btnFinish2, "Ends this demo and go on to the next")
nS_ControlSetTooltip(txtName2, "Just enter your name!")
nS_ControlSetTooltip(chkRock2, "Check for rock")
nS_ControlSetTooltip(chkPunk2, "Check for punk")
nS_ControlSetTooltip(chkTechno2, "Check for techno")
nS_ControlSetTooltip(chkClassical2, "Check for classical")
nS_ControlSetCaption(btnCheck2, "Check all")
nS_ControlEnable(chkClassical2, False)

nS_ControlSetPosition(pnlBkg2, scrWidth/2+1, scrHeight/4)
nS_ControlSetPosition(btnFinish2, scrWidth/2+scrWidth/2 - 125, scrHeight/4*3 - 50)
nS_ControlSetPosition(txtName2, scrWidth/2+scrWidth*0.2, scrHeight/4 + 15)
nS_ControlSetPosition(pnlDn2, scrWidth/2+scrWidth/12, scrHeight/4+50)
nS_ControlSetPosition(chkRock2, scrWidth/2+scrWidth/12+10, scrHeight/4+65)
nS_ControlSetPosition(chkPunk2, scrWidth/2+scrWidth/12+10, scrHeight/4+90)
nS_ControlSetPosition(chkTechno2, scrWidth/2+scrWidth/12+10, scrHeight/4+115)
nS_ControlSetPosition(chkClassical2, scrWidth/2+scrWidth/12+10, scrHeight/4+140)
nS_ControlSetPosition(btnCheck2, scrWidth/2+scrWidth/4, scrHeight/4+65)

ClsColor 0, 0, 0
While Not bFinish

	bFinish = KeyHit(1)

	DemoBeginFrame()
	
	nS_UpdateGUI()
	
	bFinish = bFinish Or nS_ControlClicked(btnFinish) Or nS_ControlClicked(btnFinish2)
	If nS_ControlClicked(btnCheck) Then
		If Not bChecked Then
			bChecked = True
			nS_CheckBoxSetChecked(chkRock, True)
			nS_CheckBoxSetChecked(chkPunk, True)
			nS_CheckBoxSetChecked(chkClassical, True)
			nS_ControlSetCaption(btnCheck, "Uncheck all")
		Else
			bChecked = False
			nS_CheckBoxSetChecked(chkRock, False)
			nS_CheckBoxSetChecked(chkPunk, False)
			nS_CheckBoxSetChecked(chkClassical, False)
			nS_ControlSetCaption(btnCheck, "Check all")
		End If
	End If
	If nS_ControlClicked(btnCheck2) Then
		If Not bChecked2 Then
			bChecked2 = True
			nS_CheckBoxSetChecked(chkRock2, True)
			nS_CheckBoxSetChecked(chkPunk2, True)
			nS_CheckBoxSetChecked(chkTechno2, True)
			nS_ControlSetCaption(btnCheck2, "Uncheck all")
		Else
			bChecked2 = False
			nS_CheckBoxSetChecked(chkRock2, False)
			nS_CheckBoxSetChecked(chkPunk2, False)
			nS_CheckBoxSetChecked(chkTechno2, False)
			nS_ControlSetCaption(btnCheck2, "Check all")
		End If
	End If	
	nS_DrawGUI()
	nS_DrawLabel scrWidth / 15, scrHeight/4 + 15, "Enter your name:"
	nS_DrawLabel scrWidth/2 + scrWidth / 15, scrHeight/4 + 15, "Enter your name:", False, False, nS_STYLE_NS2GUI
	
	DemoEndFrame("GUI Demo")
Wend

Reset()