; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; 2D over 3D demo
ClsColor 0, 0, 0
CameraRange cam, 0.1, 100
TurnEntity cam, 0, 315, 0
MoveEntity camview, 0, 1000, 0
CameraClsMode cam, True, True
CameraClsMode camview, False, True
CameraRange camview, 0.1, 100

; Floor
mdlFloor = CreatePlane()
MoveEntity mdlFloor, 0, -3.7, 0
texFloor = LoadTexture("demos\floor.jpg")
ScaleTexture texFloor, 8, 8
EntityTexture mdlFloor, texFloor
EntityPickMode mdlFloor, 2

; Roof
mdlRoof = CreatePlane()
MoveEntity mdlRoof, 0, 8.9, 0
TurnEntity mdlRoof, 180, 0, 0
texRoof = LoadTexture("demos\roof.jpg")
ScaleTexture texRoof, 8, 8
EntityTexture mdlRoof, texRoof
EntityPickMode mdlRoof, 2

; Walls
mdlWalls = CreateCube()
FlipMesh mdlWalls
ScaleEntity mdlWalls, 25, 25, 25
texWalls = LoadTexture("demos\wall.jpg")
ScaleTexture texWalls, 0.5, 0.5
PositionTexture texWalls, 0, 0.15
EntityTexture mdlWalls, texWalls
EntityPickMode mdlWalls, 2

; Shadow
mdlShadow = CreateSphere(8)
EntityAlpha mdlShadow, 0.5
EntityColor mdlShadow, 0, 0, 0
ScaleEntity mdlShadow, 1.5, 0.1, 1.5

; Gun
mdlMP5K = LoadAnimMesh("demos\mp5k.3ds")
ScaleEntity mdlMP5K, 0.1, 0.1, 0.1
ExtractAnimSeq mdlMP5K, 0, 15
ExtractAnimSeq mdlMP5K, 16, 30

; Collision
EntityType cam, 1
EntityRadius cam, 0.5
EntityType mdlWalls, 2
Collisions 1, 2, 2, 2

; Gun shots
texHole = LoadTexture("demos\hole.png", 2)
mdlHole = CreateSprite()
ScaleSprite mdlHole, 0.5, 0.5
EntityAlpha mdlHole, 0.9
SpriteViewMode mdlHole, 2
EntityTexture mdlHole, texHole
MoveEntity mdlHole, 0, -50, 0

; Muzzle Flash
pvtFlash = CreatePivot(mdlMP5K)
PositionEntity pvtFlash, 13.6, 7.1, -12.7
Dim sprFire(20)
sprFire(0) = LoadSprite("demos\fire.bmp", 2, pvtFlash)
EntityBlend sprFire(0), 3
EntityAlpha sprFire(0), 0
ScaleSprite sprFire(0), 0.3, 0.3
For i = 1 To 20
	sprFire(i) = CopyEntity(sprFire(0), pvtFlash)
	EntityBlend sprFire(i), 3
	If i < 9 Then
		ScaleSprite sprFire(i), Float(i) / 12, Float(i) / 12
	Else
		ScaleSprite sprFire(i), 1 - Float(i) / 12, 1 - Float(i) / 12
	End If
	MoveEntity sprFire(i), Float(i) / 2 - 4, 0, 0
	EntityAlpha sprFire(i), 0
Next
flashalpha# = 0

; HUD
imgHUD = nS_LoadImage("demos\hud.tga", 2)
nS_ResizeImage imgHUD, scrWidth, scrHeight / 4
imgHUD2 = nS_LoadImage("demos\hud.tga", 2)
nS_ResizeImage imgHUD2, scrWidth, scrHeight / 4
nS_FlipImage imgHUD2, False, True
imgCrosshair = nS_LoadImage("demos\crosshair.png", 2)
nS_MidHandle imgCrosshair

HidePointer
While Not KeyHit(1)

	; Frame Update
	FPSCount = FPSCount + 1
	FrameStart = MilliSecs()
	If timFPS < FrameStart Then
		FPS = FPSCount
		FPSCount = 0
		timFPS = FrameStart + 1000
		DeltaTime = 1.0 / Float(FPS)
		nS_SetAnimTween DeltaTime
	End If
	GameTime = GameTime + DeltaTime
	
	; Wireframe mode
	If KeyHit(17) Then
		If bWireFrame Then
			bWireFrame = False
		Else
			bWireFrame = True
		End If
		WireFrame bWireFrame
	End If
	
	; Handle Movement
	MoveX = scrWidth / 2 - MouseX()
	MoveY = scrHeight / 2 - MouseY()
	If MoveX <> 0 Or MoveY <> 0 Then
		MoveMouse scrWidth / 2, scrHeight / 2
		AngleX# = EntityPitch(cam) - MoveY * 90 * DeltaTime
		AngleY# = EntityYaw(cam) + MoveX * 60 * DeltaTime
	End If
	If AngleX# > 50 Then
		AngleX# = 50
	End If
	If AngleX# < -85 Then
		AngleX# = -85
	End If
	RotateEntity cam, 0, AngleY, 0
	move = False
	acc# = 3
	If KeyDown(200) Then
		move = True
		MoveEntity cam, 0, 0, 75 * DeltaTime
		acc# = acc# + 600 * DeltaTime
	End If
	If KeyDown(208) Then
		move = True
		MoveEntity cam, 0, 0, -60 * DeltaTime
		acc# = acc# + 300 * DeltaTime
	End If
	If KeyDown(203) Then
		move = True
		MoveEntity cam, -40 * DeltaTime, 0, 0
		acc# = acc# + 120 * DeltaTime
	End If
	If KeyDown(205) Then
		move = True
		MoveEntity cam, 40 * DeltaTime, 0, 0
		acc# = acc# + 120 * DeltaTime
	End If
	RotateEntity cam, AngleX, AngleY, 0
	RotateEntity camview, AngleX, AngleY, 0
	RotateEntity mdlShadow, 0, AngleY, 0
	RotateEntity mdlMP5K, 0, AngleY, 0	

	; Shooting
	If MouseDown(1) And MilliSecs() > timNextShot Then
		timNextShot = MilliSecs() + 200
		Animate mdlMP5K, 3, 150 * DeltaTime, 2
		; Position hole
		newHole = CopyEntity(mdlHole)
		PositionEntity newHole, EntityX(cam), EntityY(cam), EntityZ(cam)
		RotateEntity newHole, AngleX + Rnd(0, acc# * 2) - acc, AngleY + Rnd(0, acc# * 2) - acc, 0
		MoveEntity newHole, 0, 0, 100
		LinePick EntityX(cam), EntityY(cam), EntityZ(cam), EntityX(newHole) - EntityX(cam), EntityY(newHole) - EntityY(cam), EntityZ(newHole) - EntityZ(cam)
		PositionEntity newHole, PickedX(), PickedY(), PickedZ()
		vp# = VectorPitch(PickedNX(), PickedNY(), PickedNZ())
		vy# = VectorYaw(PickedNX(), PickedNY(), PickedNZ())
		RotateEntity newHole, vp + 180, vy, Rand(0, 360)
		pickede = PickedEntity()
		EntityParent newHole, Pickede
		MoveEntity newHole, 0, 0, -0.0001
		flashalpha# = 4
	End If
	If Not Animating(mdlMP5K) Then
		Animate mdlMP5K, 1, 20 * DeltaTime, 1
	End If
	If flashalpha# > 0 Then
		flashalpha# = flashalpha# - 40 * DeltaTime
		If flashalpha# < 0.1 Then
			flashalpha = 0
		End If
		For i = 0 To 20
			EntityAlpha sprFire(i), flashalpha#
		Next
	End If
	
	; Head bobbing
	If move Then
		b = b + 10
		MoveEntity cam, 0, Sin(b) / 50, 0
	End If

	; World update
	UpdateWorld

	; Adjust meshes to cam
	PositionEntity mdlShadow, EntityX(cam), EntityY(mdlFloor) + 0.1, EntityZ(cam)
	PositionEntity mdlMP5K, EntityX(camview), EntityY(camview) - 1, EntityZ(camview)
	MoveEntity mdlMP5K, -0.25, 0, 1.5
	TurnEntity mdlMP5K, 0, 90, -AngleX
			
	; Rendering
	nS_Cls()
	
	; HUD
	nS_DrawImage imgHUD, 0, scrHeight * 0.75
	nS_DrawImage imgHUD2, 0, 0
	nS_DrawImage imgCrosshair, scrWidth/2, scrHeight/2
	
	; Info text
	nS_Text 0, 0, "FPS: " + FPS
	nS_Text 0, 15, "Sprites: " + SpriteCount
	
	nS_Text scrWidth/2, 30, "2D over 3D demo", True

	nS_Text scrWidth/2, scrHeight - 20, "Press ESC to go to the next demo", True
	
	RenderWorld
	SpriteCount = nS_SpriteCount
	
	; 2D Render
	Flip False

Wend
ShowPointer

Reset()