; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; Images demo
ClsColor 60, 110, 160
imgHead = nS_LoadImage("demos\head.png",2)
imgJaw = nS_LoadImage("demos\jaw.png",2)
imgEyes = nS_LoadAnimImage("demos\eyes.png",512,512,0,4,2)
imgEyeBalls = nS_LoadImage("demos\eyeballs.png",2)
nS_MidHandle imgHead
nS_MidHandle imgJaw
nS_MidHandle imgEyes
nS_MidHandle imgEyeBalls

px# = scrWidth/2
py# = scrHeight/2
offx# = 0
offy# = -15
eox# = 0
eoy# = 0
s# = 0.25
a# = 0
d# = 0
t# = 1
r# = 1
g# = 1
b# = 1
bl = 1

While Not KeyHit(1)

	DemoBeginFrame()
	
	; Draw mascott
	nS_ScaleImage imgHead, s, s, True
	nS_ScaleImage imgJaw, s, s, True
	nS_ScaleImage imgEyes, s, s, True
	nS_ScaleImage imgEyeBalls, s, s, True
	nS_RotateImage imgHead, a, True
	nS_RotateImage imgJaw, a, True
	nS_RotateImage imgEyes, a, True
	nS_RotateImage imgEyeBalls, a, True
	nS_ImageAlpha imgHead, t
	nS_ImageAlpha imgJaw, t
	nS_ImageAlpha imgEyes, t
	nS_ImageAlpha imgEyeBalls, t
	nS_ImageColor imgHead, r*255, g*255, b*255
	nS_ImageColor imgJaw, r*255, g*255, b*255
	nS_ImageColor imgEyes, r*255, g*255, b*255
	nS_ImageColor imgEyeBalls, r*255, g*255, b*255
	nS_ImageBlend imgHead, bl
	nS_ImageBlend imgJaw, bl
	nS_ImageBlend imgEyes, bl
	nS_ImageBlend imgEyeBalls, bl
	nS_DrawImage imgHead, px, py
	nS_DrawImage imgJaw, px+(offx*Cos(a)-offy*Sin(a))*s, py+(offy*Cos(a)+offx*Sin(a))*s
	nS_DrawImage imgEyeBalls, px+(eox*Cos(a)-eoy*Sin(a))*s, py+(eoy*Cos(a)+eox*Sin(a))*s
	If (Not AnimatedEyes) And Rand(1, 100) = 1 And tim# < GameTime Then
		AnimatedEyes = True
		nS_AnimateImage imgEyes, nS_ANIM_PINGPONG, 25, 0, 3
		tim = GameTime + 1.75 + Rnd(0, 1.5)
	End If
	If AnimatedEyes Then
		nS_DrawImage imgEyes, px, py
	End If
	If Not nS_IsAnimImagePlaying(imgEyes) Then
		AnimatedEyes = False
	End If
	If MovingEyes# = 0 And Rand(1, 100) = 1 And tim2# < GameTime Then
		MovingEyes = DeltaTime
		tim2 = GameTime + 3 + Rnd(0, 2)
	End If
	If MovingEyes > 0 Then
		If MovingEyes > 1.8 Then
			MovingEyes = 0
			eox = 0
			eoy = 0
		Else
			eox = Sin(MovingEyes*100) * 10
			eoy = Sin(MovingEyes*100) * 10
			MovingEyes = MovingEyes + DeltaTime
		End If
	End If
		
	; Interface
	m = MouseDown(1)
	scalespeed# = 0.5 * DeltaTime
	anglespeed# = 50 * DeltaTime
	colorspeed# = 0.75 * DeltaTime
	closespeed# = 100 * DeltaTime
	sidespeed# = 30 * DeltaTime
	If DrawButton(25, 50, 90, 20, "Scale up", m) Then s = s + scalespeed : If s > 1.5 Then s = 1.5
	If DrawButton(25, 80, 90, 20, "Scale down", m) Then s = s - scalespeed : If s < 0.1 Then s = 0.1
	If DrawButton(25, 110, 90, 20, "Turn left", m) Then a = a - anglespeed
	If DrawButton(25, 140, 90, 20, "Turn right", m) Then a = a + anglespeed
	If DrawButton(25, 170, 90, 20, "Alpha up", m) Then t = t + colorspeed : If t > 1 Then t = 1
	If DrawButton(25, 200, 90, 20, "Alpha down", m) Then t = t - colorspeed : If t < 0 Then t = 0
	If DrawButton(25, 230, 90, 20, "Red up", m) Then r = r + colorspeed : If r > 1 Then r = 1
	If DrawButton(25, 260, 90, 20, "Red down", m) Then r = r - colorspeed : If r < 0 Then r = 0
	If DrawButton(25, 290, 90, 20, "Green up", m) Then g = g + colorspeed : If g > 1 Then g = 1
	If DrawButton(25, 320, 90, 20, "Green down", m) Then g = g - colorspeed : If g < 0 Then g = 0
	If DrawButton(25, 350, 90, 20, "Blue up", m) Then b = b + colorspeed : If b > 1 Then b = 1
	If DrawButton(25, 380, 90, 20, "Blue down", m) Then b = b - colorspeed : If b < 0 Then b = 0
	If DrawButton(25, 410, 90, 20, "Open mouth", m) Then offy = offy + closespeed : If offy > 130 Then offy = 130
	If DrawButton(25, 440, 90, 20, "Close mouth", m) Then offy = offy - closespeed : If offy < -15 Then offy = -15
	If DrawButton(25, 470, 90, 20, "Mouth left", m) Then offx = offx + sidespeed : If offx > 15 Then offx = 15
	If DrawButton(25, 500, 90, 20, "Mouth right", m) Then offx = offx - sidespeed : If offx < -15 Then offx = -15
	nS_Color 255, 255, 255, 0.5
	nS_Rect 145, 50, scrWidth - 195, scrHeight - 100, False, 5
	If MouseX() >= 145 And MouseX() <= (scrWidth - 50) And MouseY() >= 50 And MouseY() < (scrHeight - 50) And m Then
		px = MouseX()
		py = MouseY()
	End If
	
	DemoEndFrame("Smooth and fast extended images (buttons, drag in rectangle)")
Wend

Function DrawButton(x, y, w, h, t$, mh)
	If mh Then
		If MouseX() >= x And MouseX() <= x+w And MouseY() >= y And MouseY() <= y+h Then
			p = True
		End If
	End If
	If p Then
		nS_Color 160, 155, 145
		nS_Rect x+5, y+5, w, h
		nS_Text x+w/2+5, y+h/2+3, t, True, True
	Else
		nS_Color 0, 0, 0, 0.5
		nS_Rect x+5, y+5, w, h
		nS_Color 170, 165, 155
		nS_Rect x, y, w, h
		nS_Text x+w/2, y+h/2-2, t, True, True
	End If
	Return p
End Function

Reset()