; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; Lighting
Type ball
	Field sprite
	Field x#
	Field y#
	Field velx#
	Field vely#
End Type

sprBall = nS_LoadImage("demos\ball.bmp", 4, False)
nS_MidHandle sprBall

For i = 1 To 20
	balls.ball = New ball
	balls\x = Rnd(32, scrWidth - 32)
	balls\y = Rnd(32, scrHeight - 32)
	k = False
	For bb.ball = Each ball
		If bb <> balls Then
			If nS_ImagesCollide(sprBall, balls\x, balls\y, 0, bb\sprite, bb\x, bb\y, 0) Then
				Delete balls
				k = True
				Exit
			End If
		EndIf
	Next
	If Not k Then
		balls\sprite = nS_CopyImage(sprBall)
		balls\velx = Rnd(0, 5) - 2.5
		balls\vely = Rnd(0, 5) - 2.5
		nS_ImageColor(balls\sprite, 255, 255, 255)
		nS_ImageLightAffect balls\sprite, True, True
		nS_ImageFX balls\sprite, nS_FX_FULLBRIGHT+nS_FX_VERTEXCOLOR+nS_FX_FORCEALPHABLEND
	End If
Next

rad = scrWidth / 5
lgtRed = nS_CreateLight(rad * 1.5, rad * 0.75, rad, 255, 0, 0, 2.2)
lgtGreen = nS_CreateLight(rad * 3, rad * 0.75, rad, 0, 255, 0, 2.2)
lgtBlue = nS_CreateLight(rad * 1.5, rad * 2, rad, 0, 0, 255, 2.2)
lgtWhite = nS_CreateLight(rad * 3, rad * 2, rad, 255, 255, 255, 2.2)
lgtBlack = nS_CreateLight(rad * 4, rad * 1.5, rad*0.75, 255, 255, 255, 10, 0.1, True)

SetBuffer BackBuffer()
ClsColor 35, 130, 80

spd# = 100

While Not KeyHit(1)

	DemoBeginFrame()

	nS_Color 255, 0, 0
	nS_Text rad * 1.5, rad * 0.75, "Red light", True, True
	nS_Oval rad * 1.5 - rad, rad * 0.75 - rad, rad * 2, rad * 2, False, 3
	nS_Color 0, 255, 0
	nS_Text rad * 3, rad * 0.75, "Green light", True, True
	nS_Oval rad * 3 - rad, rad * 0.75- rad, rad * 2, rad * 2, False, 3
	nS_Color 0, 0, 255
	nS_Text rad * 1.5, rad * 2, "Blue light", True, True
	nS_Oval rad * 1.5 - rad, rad * 2 - rad, rad * 2, rad * 2, False, 3
	nS_Color 255, 255, 255
	nS_Text rad * 3, rad * 2, "White light", True, True
	nS_Oval rad * 3 - rad, rad * 2 - rad, rad * 2, rad * 2, False, 3
	nS_Color 0, 0, 0, 0.5
	nS_Text rad * 4, rad * 1.5, "Black hole", True, True
	nS_Oval rad * 4- rad*0.75, rad*1.5 - rad*0.75, rad*1.5, rad*1.5, False, 10
	
	If KeyDown(200) Then
		spd = spd + DeltaTime * 100
	End If
	If KeyDown(208) Then
		spd = spd - DeltaTime * 100
		If spd < 0 Then spd = 0
	End If
	For balls.ball = Each ball
		mov# = balls\velx * DeltaTime * spd#
		If Abs(mov) > 5 Then
			mov = 5 * Sgn(mov)
		End If
		balls\x = balls\x + mov
		mov# = balls\vely * DeltaTime * spd#
		If Abs(mov) > 5 Then
			mov = 5 * Sgn(mov)
		End If
		balls\y = balls\y + mov
		If balls\x >= scrWidth - 32 Or balls\x <= 32 Then
			balls\velx = -balls\velx
		End If
		If balls\y >= scrHeight - 32 Or balls\y <= 32 Then
			balls\vely = -balls\vely
		End If
		nS_DrawImage balls\sprite, balls\x, balls\y
		
		For bb.ball = Each ball
			If bb <> balls Then
				If nS_ImagesCollide(balls\sprite, balls\x, balls\y, 0, bb\sprite, bb\x, bb\y, 0) Then
					xd# = balls\x - bb\x
					yd# = balls\y - bb\y
					balls\velx = Abs(balls\velx) * Sgn(xd#)
					balls\vely = Abs(balls\vely) * Sgn(yd#)
					bb\velx = Abs(bb\velx) * -Sgn(xd#)
					bb\vely = Abs(bb\vely) * -Sgn(yd#)
					tdx# = balls\velx * 0.7 + Abs(bb\velx) * Sgn(xd#) * 0.3
					tdy# = balls\vely * 0.7 + Abs(bb\vely) * Sgn(yd#) * 0.3
					bb\velx = bb\velx * 0.7 + Abs(balls\velx) * -Sgn(xd#) * 0.3
					bb\vely = bb\vely * 0.7 + Abs(balls\vely) * -Sgn(yd#) * 0.3
					balls\velx = tdx#
					balls\vely = tdy#
					Exit
				End If
			EndIf
		Next
	Next	
	
	DemoEndFrame("Lighting & pixel-perfect collisions [up/down - speed: " + spd + "]")
Wend

Reset()