; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; New lights demo

; Dwarf
imgDwarf = nS_LoadAnimImage("demos\dwarf.png", 96, 96, 0, 16)
imgDwarfShadow1 = nS_LoadAnimImage("demos\dwarf.png", 96, 96, 0, 16)
imgDwarfShadow2 = nS_LoadAnimImage("demos\dwarf.png", 96, 96, 0, 16)
nS_HandleImage imgDwarf, 50, 67
nS_ImageColor imgDwarfShadow1, 0, 0, 0
nS_HandleImage imgDwarfShadow1, 50, 67
nS_ImageAlpha imgDwarfShadow1, 0.5
nS_ImageColor imgDwarfShadow2, 0, 0, 0
nS_HandleImage imgDwarfShadow2, 46, 29
nS_ImageAlpha imgDwarfShadow2, 0.5
nS_FlipImage imgDwarfShadow2, False, True

fOffSetX# = 175
fPosX# = fOffSetX
fPosY# = scrHeight - 80
bUp = True
nS_AnimateImage imgDwarf, nS_ANIM_LOOP, 10, 0, 7
nS_AnimateImage imgDwarfShadow1, nS_ANIM_LOOP, 10, 0, 7
nS_AnimateImage imgDwarfShadow2, nS_ANIM_LOOP, 10, 0, 7

; Environment
imgGroundBase = nS_LoadImage("demos\ground.png")
imgGround = nS_CreateSubImage(imgGroundBase, 0, 0, 64, 48)
imgPath = nS_LoadImage("demos\path.png")
imgTrees = nS_LoadImage("demos\trees.tga", 2)
Const TrC = scrWidth / 6
Local trx[TrC]
Local try[TrC]
Local tr[TrC]
For i = 0 To TrC
	trx[i] = Rand(0, scrWidth+200) - 100
	try[i] = Rand(0, scrHeight+200) - 100
	ox = Rand(0, 3)
	oy = Rand(0, 1)
	tr[i] = nS_CreateSubImage(imgTrees, ox*128, oy*128, 128, 128)
	iy = scrHeight + 32
	For ix = 0 To scrWidth Step 128
		iy = iy - 96
		If RectsOverlap(ix, iy, 128, 96, trx[i], try[i], 128, 128) Then
			i = i - 1
			Exit
		End If
	Next
Next

; Light
fPosL1X# = 0
fPosL1Y# = 0
fPosL2X# = 0
fPosL2Y# = 0
imgLight = nS_LoadImage("demos\light.png", 2)
nS_MidHandle imgLight
nS_ScaleImage imgLight, 0.5, 0.5

While Not KeyHit(1)

	DemoBeginFrame()
	
	; Environment
	For ix = 0 To scrWidth Step 64
		For iy = 0 To scrHeight Step 48
			nS_DrawImage imgGround, ix, iy
		Next
	Next
	iy = scrHeight + 32
	For ix = 0 To scrWidth Step 128
		iy = iy - 96
		nS_DrawImage imgPath, ix, iy
	Next
	For i = 0 To TrC
		nS_DrawImage tr[i], trx[i], try[i]
	Next
	
	; Dwarf movement & render
	If bUp Then
		fPosX = fPosX + DeltaTime*40
		fPosY = fPosY - DeltaTime*30
		If fPosX > scrWidth - fOffSetX Then
			bUp = False
			nS_AnimateImage imgDwarf, nS_ANIM_LOOP, 10, 8, 15
			nS_AnimateImage imgDwarfShadow1, nS_ANIM_LOOP, 10, 8, 15
			nS_AnimateImage imgDwarfShadow2, nS_ANIM_LOOP, 10, 8, 15
		End If
	Else
		fPosX = fPosX - DeltaTime*40
		fPosY = fPosY + DeltaTime*30
		If fPosX < fOffSetX Then
			nS_AnimateImage imgDwarf, nS_ANIM_LOOP, 10, 0, 7
			nS_AnimateImage imgDwarfShadow1, nS_ANIM_LOOP, 10, 0, 7
			nS_AnimateImage imgDwarfShadow2, nS_ANIM_LOOP, 10, 0, 7
			bUp = True
		End If
	End If	
	nS_DrawImage imgDwarfShadow1, fPosX, fPosY
	nS_DrawImage imgDwarfShadow2, fPosX, fPosY
	nS_DrawImage imgDwarf, fPosX, fPosY

	; Light & Shadow Update
	fPosL1X = Sin(GameTime*50)*(scrWidth/2)+scrWidth/2
	fPosL1Y = scrHeight - 50
	fDX# = fPosX - fPosL1X
	fDY# = fPosY - fPosL1Y
	fD# = Sqr(fDX*fDX+fDY*fDY)
	nS_RotateImage imgDwarfShadow1, ATan(-fDX/fDY), True
	nS_ScaleImage imgDwarfShadow1, 1.0+10.0/fD, 0.5+100.0/fD, True
	nS_ImageAlpha imgDwarfShadow1, 50.0/fD
	fPosL2X = Sin(GameTime*80)*(scrWidth/2)+scrWidth/2
	fPosL2Y = 50
	fDX# = fPosX - fPosL2X
	fDY# = fPosY - fPosL2Y
	fD# = Sqr(fDX*fDX+fDY*fDY)
	nS_RotateImage imgDwarfShadow2, ATan(-fDX/fDY), True
	nS_ScaleImage imgDwarfShadow2, 1.0+10.0/fD, 0.5+100.0/fD, True
	nS_ImageAlpha imgDwarfShadow2, 50.0/fD
	If lgt1 Then
		nS_MoveLight lgt1, fPosL1X, fPosL1Y
		nS_MoveLight lgt2, fPosL2X, fPosL2Y
	End If
	
	; Light Settings
	bSwitch = False
	If KeyHit(57) Then
		iLighting = (iLighting + 1) Mod 4
		Select iLighting
			; No lighting
			Case 0
				nS_FreeLight lgt1
				nS_FreeLight lgt2
				lgt1 = 0
				nS_AmbientLight 255, 255, 255
				nS_ImageLightAffect imgGround, True, False
				nS_ImageLightAffect imgPath, True, False
				nS_ImageLightAffect imgDwarf, True, False
				For i = 0 To TrC
					nS_ImageFX tr[i], nS_FX_FULLBRIGHT
					nS_ImageLightAffect tr[i], True, False
				Next
				nS_DrawImage imgGround, -1000, -1000
				nS_DrawImage imgPath, -1000, -1000
				nS_DrawImage imgDwarf, -1000, -1000
				For i = 0 To TrC
					nS_DrawImage tr[i], -1000, -1000
				Next
				nS_ImageFX imgGround, nS_FX_FULLBRIGHT
				nS_ImageFX imgPath, nS_FX_FULLBRIGHT
				nS_ImageFX imgDwarf, nS_FX_FULLBRIGHT
				nS_ImageLightAffect imgGround, False
				nS_ImageLightAffect imgPath, False
				nS_ImageLightAffect imgDwarf, False
				For i = 0 To TrC
					nS_ImageLightAffect tr[i], False
				Next
			; Ambient Lighting only
			Case 1
				nS_AmbientLight 80, 120, 160
				nS_ImageFX imgGround, nS_FX_NONE
				nS_ImageLightAffect imgGround, True 
				nS_ImageFX imgPath, nS_FX_NONE
				nS_ImageLightAffect imgPath, True 
				nS_ImageFX imgDwarf, nS_FX_NONE
				nS_ImageLightAffect imgDwarf, True 
				For i = 0 To TrC
					nS_ImageFX tr[i], nS_FX_NONE
					nS_ImageLightAffect tr[i], True 
				Next
			; Lighting but not vertex-lit
			Case 2
				If Not lgt1 Then
					lgt1 = nS_CreateLight(fPosL1X, fPosL1Y, 300, 235, 225, 195, 1)
					lgt2 = nS_CreateLight(fPosL2X, fPosL2Y, 300, 235, 225, 195, 1)
				End If
			; Vertex lighting
			Case 3
				nS_ImageLightAffect imgGround, True, True
				nS_ImageFX imgGround, nS_FX_VERTEXCOLOR
				nS_ImageLightAffect imgPath, True, True
				nS_ImageFX imgPath, nS_FX_VERTEXCOLOR
				nS_ImageLightAffect imgDwarf, True, True
				nS_ImageFX imgDwarf, nS_FX_VERTEXCOLOR
				For i = 0 To TrC
					nS_ImageLightAffect tr[i], True, True
					nS_ImageFX tr[i], nS_FX_VERTEXCOLOR
				Next
				If Not lgt1 Then
					lgt1 = nS_CreateLight(fPosL1X, fPosL1Y, 300, 235, 225, 195, 1)
					lgt2 = nS_CreateLight(fPosL2X, fPosL2Y, 300, 235, 225, 195, 1)
				End If
		End Select
	End If
	
	nS_DrawImage imgLight, fPosL1X, fPosL1Y
	nS_DrawImage imgLight, fPosL2X,fPosL2Y	
	nS_DrawImage imgLight, fPosL1X, fPosL1Y
	nS_DrawImage imgLight, fPosL2X,fPosL2Y
	
	nS_Color 0, 0, 0, 0.5
	nS_Rect 0, 0, 200, 30
	nS_Rect scrWidth / 3, 30, 430, 15
	nS_Rect 30, 70, 150, 120
	nS_Rect 30, 200, 150, 75
	
	nS_Text 30, 70, "Current mode:"
	Select iLighting
		Case 0
			nS_Text 35, 85, "No lighting"
		Case 1
			nS_Text 35, 85, "Ambient lighting"
		Case 2
			nS_Text 35, 85, "2 Standard Lights"
			nS_Text 35, 100, "Gives problem with"
			nS_Text 35, 115, "image duplicates,"
			nS_Text 35, 130, "only the trees and"
			nS_Text 35, 145, "dwarf are correctly"
			nS_Text 35, 160, "lit as they are not"
			nS_Text 35, 175, "copied on render."
		Case 3
			nS_Text 35, 85, "2 Vertex Lights"
			nS_Text 35, 100, "Everything is lit"
			nS_Text 35, 115, "properly!"
	End Select
	
	nS_Text 30, 200, "The shadows are"
	nS_Text 30, 215, "rendered dynamically"
	nS_Text 30, 230, "as black copies"
	nS_Text 30, 245, "The lights are not"
	nS_Text 30, 260, "affected by lighting"
	
	DemoEndFrame("More Complex Light System (SPACE to switch lighting mode)")
Wend

Reset()