; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; Particle system demo
imgSmoke = nS_LoadImage("demos\smoke.png", 2)
nS_ImageAlpha imgSmoke, 0.2
nS_MidHandle imgSmoke
emtSmoke = nS_CreateEmitter()
nS_SetEmitter emtSmoke, 0, 96
nS_SetParticle emtSmoke, imgSmoke, 10, 1
nS_SetVelocity emtSmoke, 0, -75, 50, 30, 0.8, 1, 0
nS_SetScale emtSmoke, 0.5, 0.5, 0.1, 0.1, 0.97, 0.97
nS_PositionEmitter emtSmoke, scrWidth / 4, scrHeight / 2
	
imgFire = nS_LoadImage("demos\fire.tga", 2)
nS_ImageBlend imgFire, nS_BLEND_ADDITIVE
nS_MidHandle imgFire
emtFlameThrower = nS_CreateEmitter()
nS_SetEmitter emtFlameThrower, 0, 72
nS_SetParticle(emtFlameThrower, imgFire, 0.3, 0)
nS_SetVelocity(emtFlameThrower, 300, -45, 50, 30, 0.99, 0.99, 0.2)
nS_SetRotation(emtFlameThrower, 0, 15, 0, 1)
nS_SetScale(emtFlameThrower, 1.2, 1.2, 0.3, 0.3, 2.5, 2.5)
nS_PositionEmitter emtFlameThrower, scrWidth / 2, scrHeight / 2

imgSpark = nS_LoadImage("demos\spark.png", 2)
nS_MidHandle imgSpark
nS_ImageBlend imgSpark, nS_BLEND_ADDITIVE

While Not KeyHit(1)

	DemoBeginFrame()

	If KeyHit(57) Then
		emtSpark = nS_CreateEmitter()
		nS_SetEmitter emtSpark, 15, 9000
		nS_SetParticle(emtSpark, imgFire, 1.2, 0)
		nS_SetVelocity(emtSpark, 0, -200, 400, 300, 0.7, 0.7, 900)
		nS_SetRotation(emtSpark, 0, 360, 0, 360)
		nS_SetScale(emtSpark, 0.2, 0.2, 0, 0, 0.3, 0.3)
		nS_PositionEmitter emtSpark, scrWidth / 4 * 3, scrHeight / 2
	End If
	
	; Particle system update
	nS_UpdateEmitters(DeltaTime)
	PartCount = nS_UpdateParticles(DeltaTime)
	nS_Text 0, 30, "Particles: " + PartCount

	DemoEndFrame("Particle system (includes blending modes) [space]")

Wend

Reset()