; nSprite 2 Demos
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; Void Requiem
sprVoid = nS_LoadImage("demos\void.jpg", 0)
nS_ResizeImage sprVoid, scrWidth, scrHeight
nS_ImageBlend sprVoid, nS_BLEND_ADDITIVE
ClsColor 0, 0, 0
nS_Cls
nS_DrawImage sprVoid, 0, 0
RenderWorld
Flip
nS_ImageAlpha sprVoid, 0.25
While Not KeyHit(1)

	; Frame Update
	FPSCount = FPSCount + 1
	FrameStart = MilliSecs()
	If timFPS < FrameStart Then
		FPS = FPSCount
		FPSCount = 0
		timFPS = FrameStart + 1000
		DeltaTime = 1.0 / Float(FPS)
		nS_SetAnimTween DeltaTime
	End If
	GameTime = GameTime + DeltaTime
	
	; Wireframe mode
	If KeyHit(17) Then
		If bWireFrame Then
			bWireFrame = False
		Else
			bWireFrame = True
		End If
		WireFrame bWireFrame
	End If
	
	; Rendering
	nS_Cls(False)
	
	If MouseHit(1)
		nS_DrawImage sprVoid, Float(MouseX()-scrWidth/2)/25, Float(MouseY()-scrHeight/2)/25
	End If
	If MouseHit(2)
		nS_Cls
	End If
	
	nS_Color 0, 0, 0
	nS_Rect 0, 0, 150, 30
	nS_Text 0, 0, "FPS: " + FPS
	nS_Text 0, 15, "Sprites: " + SpriteCount
	
	nS_Text scrWidth/2, 30, "See Void Requiem game demo for more effects", True
	nS_Text scrWidth/2, 45, "and to see them all at the same time [left and right click]", True

	nS_Text scrWidth/2, scrHeight - 20, "Press ESC to go to the next demo", True
	
	RenderWorld
	SpriteCount = nS_SpriteCount
	
	; 2D Render
	Flip False

Wend

Reset()