; nSprite 2 - 3D Accelerated 2D Games Creation Package for Blitz3D
; Last Updated: November 15th 2020
; Version: 1.2.0

; Copyright (c) 2020 Jocelyn Perreault
;
; This software is provided 'as-is', without any express or implied
; warranty. In no event will the authors be held liable for any damages
; arising from the use of this software.
;
; Permission is granted to anyone to use this software for any purpose,
; including commercial applications, and to alter it and redistribute it
; freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must not
;    claim that you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation would be
;    appreciated but is not required.
; 2. Altered source versions must be plainly marked as such, and must not be
;    misrepresented as being the original software.
; 3. This notice may not be removed or altered from any source distribution.

; 3D Object
Type Object3D
	Field entity
End Type

; Convert a entity to a 3D object
Function nS_Convertentity%(entity%)
	Local o.Object3D = New Object3D
	ScaleEntity entity, nS_Scale, -nS_Scale, -nS_Scale
	EntityParent entity, nS_pvtTopLeft
	o\entity = entity
	Return Handle(o)
End Function

; Position the object on the screen in 2D
Function nS_Position3DObject(obj%, fX#, fY#)
	Local o.Object3D = Object.Object3D(obj)
	PositionEntity o\entity, fX + 0.5, fY + 0.5, nS_ZBuffer
	nS_ZBuffer = nS_ZBuffer + 0.1
End Function

; Scale the object
Function nS_Scale3DObject(obj%, fX#, fY#, fZ#)
	Local o.Object3D = Object.Object3D(obj)
	ScaleEntity o\entity, fX, fY, fZ
End Function

; Rotate the object
Function nS_Rotate3DObject(obj%, fX#, fY#, fZ#)
	Local o.Object3D = Object.Object3D(obj)
	RotateEntity o\entity, fX, fY, fZ
End Function

; Turn the object
Function nS_Turn3DObject(obj%, fX#, fY#, fZ#)
	Local o.Object3D = Object.Object3D(obj)
	TurnEntity o\entity, fX, fY, fZ
End Function